<template>
  <div class="BookmarksTab _tabcontent">
    <tab-simple
      v-model="items"
      :is-tab-active="isTabActive"
      key-title="url"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      @onTabActive="onTabActive"
      :creatable="false"
      :fussysortKeys="['name', 'url', 'folder']"
      tab-name="bookmarks"
      single-item="bookmark">
      <template slot="icon" slot-scope="prop">
        <span
          class="_icon"
          :style="{ backgroundImage: 'url(' + (!prop.item.url.includes('npmjs.com') ? prop.item.icon : 'https://static.npmjs.com/5f6e93af5bf0f5dcdd1eecdac99f51ee.png') + ')' }"></span>
      </template>
    </tab-simple>
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: [],
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
  },
  methods: {
    async onTabActive() {
      if (!this.items.length) {
        const { data } = await this.$axios.get(`/bookmarks/get`)
        this.items = data
      }
    },
    leftClick(item) {
      open(item.url)
      win.close()
    },
    rightClick(item) {
      const clipboard = nw.Clipboard.get()
      clipboard.set(item.url, 'text')
      this.$axios.post('/notify', {
        text: item.url,
        title: 'copied to clipboard',
        icon: 'success.png',
      })
    },
    middleClick(item) {
      open(item.url)
    },
  }
}
</script>

<style lang="less" scoped>
@import "./BookmarksTab.less";
</style>